define([
// Dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    "./_ActivityViewModel",
// Resources
    "epi/i18n!epi/cms/nls/episerver.shared.action"
],
function(
// Dojo
    declare,
    lang,
// Epi 
    _ActivityViewModel,
// Resources
    localization
) {

    return declare([_ActivityViewModel], {

        // sendLabel: [public] String
        //      Label for sending form
        sendLabel: localization.save,

        save: function(comment) {

            var promise;

            //If the id is set update the comment, otherwise create a new            
            if (this.id) {
                promise = this.activityService.saveComment(this.id, this.activityId, comment);
            } else {
                promise = this.activityService.addComment(this.activityId, comment);
            }
            promise.otherwise(lang.hitch(this, "_handleError"));

            return promise;

        }
    });
});