define([
// Dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
// Epi
    "./_ActivityViewModel",
// Resources
    "epi/i18n!epi/cms/nls/episerver.cms.activities.activity.message"
],
function(
// dojo
    declare,
    lang,
// epi
    _ActivityViewModel,
// resources
    localization
    ) {

    return declare([_ActivityViewModel], {

        // hasMessage: [public] Boolean
        //      Indicates whether this activity has a message. Used to
        //      determine the edit label.
        hasMessage: false,

        _editLabelGetter: function() {
            // summary:
            //      Gets the edit label.
            // tags:
            //      private

            return this.hasMessage ? localization.reply.label : localization.comment.label;
        },

        save: function(message) {
            // summary:
            //      Add a new comment
            // tags:
            //      public
            var promise =  this.activityService.addComment(this.id, message);
            promise.otherwise(lang.hitch(this, "_handleError"));
            return promise;
        }
    });
});
