define([
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/Stateful",
    "epi/datetime",
    // Epi
    "epi/dependency",
    // Resources
    "epi/i18n!epi/cms/nls/episerver.cms.activities.activity",
    "epi/i18n!epi/cms/nls/episerver.shared.action"
],
function(
// Dojo
    declare,
    lang,
    Stateful,
	datetime,
// Epi
    dependency,
// Resources
    activitiesResources,
    actionResources
    ) {

    return declare([Stateful], {
        // summary:
        //      The view model for the Activity comments
        // tags:
        //      internal abstract
        activitiesResource: activitiesResources,

        activityService: null,

        editLabel: activitiesResources.message.edit.label,

        // sendLabel: [public] String
        //      Label for sending form
        sendLabel: actionResources.post,

        // resetLabel: [public] String
        //      Label for reset form
        resetLabel: actionResources.cancel,

        // errorMessage: [public] String
        //      Error message when post fails
        errorMessage: "",

        // isEditEnabled: [public] Boolean
        //      A flag indicating whether to allow edit capabilities
        isEditEnabled: true,

        // readOnly: [public] boolean
        //      A flag indicating if the widget should be read only
        readOnly: true,

        // readOnly: [public] boolean
        //      Hide buttons when post is triggered
        hideOnPost: true,

        // placeholderText: [public] String
        //      Placeholder text for textarea
        placeholderText: "",

        postscript: function() {
            this.inherited(arguments);

            this.activityService = this.activityService || dependency.resolve("epi.cms.ActivityService");
            this.profile = this.profile || dependency.resolve("epi.shell.Profile");
        },

        save: function(message) {
            // summary:
            //
            // tags:
            //      public abstract
        },
        _handleError: function() {
            // summary:
            //      Sets error message
            // tags:
            //      private
            this.set("errorMessage", activitiesResources.errormessage);

        },
        _isEditEnabledGetter: function() {
            // summary:
            //      Returns whether edit should be enabled
            // description:
            //      Overridden to disallow editing for others than original authors
            // tags:
            //      private

            // If message property is set, we do not want offer other users than the original author to edit
            if(this.message) {
                return (this.author || this.changedBy) === this.profile.userName;
            }
            return this.isEditEnabled;
        }
    });
});
